#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"

#define Maxtime	pow(10,4)		//time
#define c		0.3				//parameter c
#define M		5				//paremeter M
double a[M] = { 0.3 , 0.5 , -0.4 , -0.2 , 0.65};	//parameter a_i
dsfmt_t dsfmt1;


double rand_gauss( double mu , double sigma ){	//rand : gauss
	double x1 = dsfmt_genrand_close_open(&dsfmt1);
	double x2 = dsfmt_genrand_close_open(&dsfmt1);
	double y  = sigma * ( sqrt(-2 * log(x1) ) * cos( 2*M_PI * x2)) + mu;
	return y;
}


int main(void){
	dsfmt_init_gen_rand(&dsfmt1,1);
	
	int t,i;
	double rand;
	double *x;
	x = (double *)calloc( Maxtime, sizeof(double));
	
	FILE *fp;
	if( (fp=fopen("problem3_4_6.dat","w")) ==NULL){
		printf("FILE Error\n");
		exit(1);
	}

	
	for( t=0 ; t< Maxtime ; t++){	//trial
		if( t >= M){
			rand = rand_gauss(0.0,1.0);	//random
			
			for(i=1;i<=M;i++){
				x[t] += a[i-1]*x[t-i];
			}
			x[t] += rand;
		}
		
		fprintf(fp , "%d	%f\n",t,x[t]);
	}
	
	fclose(fp);
	free(x);
	return 0;
}


